#include "stdafx.h"
#include <stdio.h>
#define USEZLIBDLL
#include "zlib.h"

#define BUFLEN	65536

static int gz_uncompress(gzFile in, FILE   *out)
{
    static char buf[BUFLEN];
    int len;
    int err;

    for (;;) {
        len = gzread(in, buf, BUFLEN);
        if (len == 0) break;

        if (fwrite(buf, 1, len, out) != len)
        	return 0;
    }
    if (fclose(out))
    	return 0;

    if (gzclose(in) != Z_OK)
    	return 0;

    return 1;
}

int file_uncompress(char *infile, char *outfile)
{
    FILE  *out;
    gzFile in;

    in = gzopen(infile, "rb");
    if (in == NULL) {
		return 0;
    }
    out = fopen(outfile, "wb");
    if (out == NULL) {
		return 1;
    }

    return gz_uncompress(in, out);
}
